package cc_petitions.survey.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.springframework.stereotype.Service;

import cc_petitions.survey.service.SurveyService;
import cc_petitions.survey.service.SurveyVO;
import egovframework.com.cop.bbs.service.BoardVO;
import egovframework.rte.fdl.cmmn.EgovAbstractServiceImpl;

@Service("surveyService")
public class SurveyServiceImpl extends EgovAbstractServiceImpl implements SurveyService {
	@Resource(name = "surveyMapper")
	private SurveyMapper surveyMapper;
	
	@Override
	public Map<String, Object> selectSurveyArticles(SurveyVO surveyVO) throws Exception {
		List<BoardVO> list = surveyMapper.selectSurveyArticleList(surveyVO);
		int cnt = surveyMapper.selectSurveyArticleListCnt(surveyVO);

		Map<String, Object> map = new HashMap<String, Object>();
		map.put("resultList", list);
		map.put("resultCnt", Integer.toString(cnt));
		
		return map;
	}

	
	@Override
	public void insertSurvey(SurveyVO surveyVO) throws Exception {
		surveyMapper.insertSurvey(surveyVO);
		
	}


	@Override
	public SurveyVO getSurvey(int que_id) throws Exception {
		SurveyVO surveyVO = surveyMapper.getSurvey(que_id);
		return surveyVO;
	}


	@Override
	public void updateSurvey(SurveyVO surveyVO) throws Exception {
		surveyMapper.updateSurvey(surveyVO);
	}


	@Override
	public void deleteSurvey(int que_id) throws Exception {
		surveyMapper.deleteSurvey(que_id);
		
	}


	@Override
	public List<SurveyVO> selectAnQueList(SurveyVO surveyVO) throws Exception {
		List<SurveyVO> selectAnQueList = surveyMapper.selectAnQueList(surveyVO);
		return selectAnQueList;
	}


	@Override
	public void insertSurveyQue(SurveyVO surveyVO) throws Exception {
		surveyMapper.insertSurveyQue(surveyVO);
	}


	@Override
	public SurveyVO getSurveyQue(int anque_id) throws Exception {
		SurveyVO survey = surveyMapper.getSurveyQue(anque_id);
		return survey;
	}


	@Override
	public void updateSurveyQue(SurveyVO surveyVO) throws Exception {
		surveyMapper.updateSurveyQue(surveyVO);
	}


	@Override
	public void deleteSurveyQue(int anque_id) throws Exception {
		surveyMapper.deleteSurveyQue(anque_id);
		
	}


	@Override
	public void insertSurveyQueItem(SurveyVO surveyVO) throws Exception {
		surveyMapper.insertSurveyQueItem(surveyVO);
		
	}


	@Override
	public void deleteSurveyQueItem(int anque_id) throws Exception {
		surveyMapper.deleteSurveyQueItem(anque_id);
	}


	@Override
	public void deleteSurveyQueAll(int que_id) throws Exception {
		surveyMapper.deleteSurveyQueAll(que_id);
		
	}


	@Override
	public void deleteSurveyQueItemAll(int que_id) throws Exception {
		surveyMapper.deleteSurveyQueItemAll(que_id);
		
	}


	@Override
	public List<SurveyVO> selectAnQueItemList(int que_id) throws Exception {
		List<SurveyVO> selectAnQueItemList = surveyMapper.selectAnQueItemList(que_id);
		return selectAnQueItemList;
	}


	@Override
	public int getSurveyQueItemIdx(int anque_id) throws Exception {
		int idx = surveyMapper.getSurveyQueItemIdx(anque_id);
		return idx;
	}


	@Override
	public void deleteSurveyQueItemReal(int anque_id) throws Exception {
		surveyMapper.deleteSurveyQueItemReal(anque_id);
		
	}


	@Override
	public int selectAnQueListCnt(SurveyVO survey) throws Exception {
		int selectAnQueList = surveyMapper.selectAnQueListCnt(survey);
		return selectAnQueList;
	}


	@Override
	public void insertSurveyResult(SurveyVO surveyVO) throws Exception {
		surveyMapper.insertSurveyResult(surveyVO);
		
	}


	@Override
	public int insertSurveyUser(SurveyVO surveyVO) throws Exception {
		int userinfo_id = surveyMapper.insertSurveyUser(surveyVO);
		return userinfo_id;
	}


	@Override
	public Map<String, Object> selectSurveyResultArticles(SurveyVO surveyVO) throws Exception {
		List<BoardVO> list = surveyMapper.selectSurveyResultArticleList(surveyVO);
		
		int cnt = surveyMapper.selectSurveyResultArticleListCnt(surveyVO);

		Map<String, Object> map = new HashMap<String, Object>();

		map.put("resultList", list);
		map.put("resultCnt", Integer.toString(cnt));
		
		return map;
	}


	@Override
	public SurveyVO getSurveyResultUser(int userinfo_id) throws Exception {
		SurveyVO userinfo = surveyMapper.getSurveyResultUser(userinfo_id);
		return userinfo;
	}


	@Override
	public List<SurveyVO> selectAnQueItemResult(int que_id) throws Exception {
		List<SurveyVO> selectAnQueItemResult = surveyMapper.selectAnQueItemResult(que_id);
		return selectAnQueItemResult;
	}


	@Override
	public int selectSurveyUser(SurveyVO userSurvey) throws Exception {
		int resultCount = surveyMapper.selectSurveyUser(userSurvey);
		return resultCount;
	}


	@Override
	public List<SurveyVO> selectQueItemList(int que_id) throws Exception {
		List<SurveyVO> selectQueItemList = surveyMapper.selectQueItemList(que_id);
		return selectQueItemList;
	}


	@Override
	public SurveyVO selectAnswerStat(SurveyVO userSurvey) throws Exception {
		return surveyMapper.selectAnswerStat(userSurvey);
	}
	
	@Override
	public int getAnswerCount(int anque_id) throws Exception {
		return surveyMapper.getAnswerCount(anque_id);
	}
	
	@Override
	public int getQuestionResultCount(int itemque_id) throws Exception {
		return surveyMapper.getQuestionResultCount(itemque_id);
	}
	
	@Override
	public String getSubjectAnswer(int itemque_id) throws Exception {
		return surveyMapper.getSubjectAnswer(itemque_id);
	}


	@Override
	public int selectApplyCnt(SurveyVO userSurvey) throws Exception {
		return surveyMapper.selectApplyCnt(userSurvey);
	}
	
}
